"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const helper_text_1 = require("@material/select/helper-text");
const app_1 = require("@pitaya-components/app");
const aurelia_framework_1 = require("aurelia-framework");
const aurelia_typed_observable_plugin_1 = require("aurelia-typed-observable-plugin");
const pi_select_1 = require("./pi-select");
const UPPER_SELECT_TAG_NAME = pi_select_1.SELECT_TAG_NAME.toLocaleUpperCase();
const logger = aurelia_framework_1.LogManager.getLogger("Pitaya:Select-Helper-Text");
let PiSelectHelperText = class PiSelectHelperText {
    constructor() {
        this.id = app_1.generateGUID();
    }
    bind() {
        try {
            const element = this._rootElement.previousElementSibling;
            if (!element || (element.tagName !== UPPER_SELECT_TAG_NAME)) {
                throw new Error("No 'pi-select' found.");
            }
            this._select = element.au.controller.viewModel;
        }
        catch (error) {
            logger.warn("When using bindable 'validate' together with a value there must be a <pi-select> custom element before <pi-select-helper-text>.");
        }
    }
    attached() {
        this._helperText = new helper_text_1.MDCSelectHelperText(this._rootElement);
        this._select && (this._select.ariaControls = this.id);
        this._select && (this._select.ariaDescribedBy = this.id);
    }
    detached() {
        this._helperText.destroy();
    }
};
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelectHelperText.prototype, "persistent", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelectHelperText.prototype, "validate", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiSelectHelperText.prototype, "error", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", String)
], PiSelectHelperText.prototype, "id", void 0);
PiSelectHelperText = __decorate([
    aurelia_framework_1.customElement("pi-select-helper-text"),
    aurelia_framework_1.viewResources(aurelia_framework_1.PLATFORM.moduleName("./pi-select-helper-text.css")),
    aurelia_framework_1.autoinject
], PiSelectHelperText);
exports.PiSelectHelperText = PiSelectHelperText;

//# sourceMappingURL=pi-select-helper-text.js.map
