import { EventType } from "@material/base/index.d";

type SelectEvent = "MDCSelect:change";

export declare class PiSelect
{
	public required: boolean;
	public disabled: boolean;
	public outlined: boolean;
	public onChange: Function;

	public withIcon: boolean;
	public withLabel: boolean;
	public ariaControls: string;
	public ariaDescribedBy: string;

	get initialized(): boolean;

	get value(): string;

	set value( value: string )

	get selectedIndex(): number;

	set selectedIndex( index: number )

	get valid(): boolean;

	set valid( isValid: boolean )

	set leadingIconAriaLabel( icon: string )

	set leadingIconContent( content: string )

	set helperTextContent( content: string )

	public layout(): void;

	public listen( eventName: SelectEvent | EventType, handler: ( event?: CustomEvent ) => void, options?: AddEventListenerOptions ): void;

	public unlisten( eventName: SelectEvent | EventType, handler: ( event?: CustomEvent ) => void, options?: AddEventListenerOptions ): void;
}